package com.agfa.wildfly.interceptor.mdb;

import javax.ejb.ActivationConfigProperty;
import javax.ejb.MessageDriven;
import javax.inject.Inject;
import javax.jms.JMSException;
import javax.jms.Message;
import javax.jms.MessageListener;
import javax.jms.TextMessage;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.agfa.wildfly.interceptor.mdb.cdi.Logged;

@MessageDriven(activationConfig = {
        @ActivationConfigProperty(propertyName = "destinationType", propertyValue = "javax.jms.Queue"),
        @ActivationConfigProperty(propertyName = "destination", propertyValue = "java:/queue/Logger/messages")
})
@Logged
public class LoggerMessageListener implements MessageListener {
    private static final Logger LOG = LoggerFactory.getLogger(LoggerMessageListener.class);
    
    @Inject StringTransformer tranformer;
    
    @Override
    public void onMessage(Message message) {
        if (message instanceof TextMessage) {
            TextMessage tm = (TextMessage) message;
            try {
                LOG.info("{} received: {}", LoggerMessageListener.class.getSimpleName(), tm.getText());
                LOG.info("message tranformed to: {}", tranformer.transform(tm.getText()));
            } catch (JMSException e) {
                LOG.error("cannot retrieve text from JMS message", e);
            }
        }
    }
}
