package com.agfa.wildfly.interceptor.mdb.cdi;

import javax.inject.Inject;
import javax.interceptor.AroundInvoke;
import javax.interceptor.Interceptor;
import javax.interceptor.InvocationContext;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.agfa.wildfly.interceptor.mdb.InterceptorCounter;

@Interceptor
@Logged
public class LoggedInterceptor {
    private final static Logger LOGGER = LoggerFactory.getLogger(LoggedInterceptor.class);
    
    @Inject InterceptorCounter counter;
    
    @AroundInvoke
    public Object logInvocation(InvocationContext ctx) throws Exception {
        try {
            LOGGER.info("Before {}::{}", ctx.getMethod().getDeclaringClass().getSimpleName(), ctx.getMethod().getName());
            counter.count();
            return ctx.proceed();
        } finally {
            LOGGER.info("After {}::{}", ctx.getMethod().getDeclaringClass().getSimpleName(), ctx.getMethod().getName());
        }
    }
}
